package com.kafka.springbootkafkatutorial.kafka;

import com.kafka.springbootkafkatutorial.payload.User;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.kafka.support.KafkaHeaders;
import org.springframework.messaging.Message;
import org.springframework.messaging.support.MessageBuilder;
import org.springframework.stereotype.Component;

@Component
public class KafkaJsonProducer {
    private static final Logger LOGGER= LoggerFactory.getLogger(KafkaProducer.class);

    @Value("${spring.kafka.topic-json.name}")
    private String jsonTopicName;

    private final KafkaTemplate<String,String> kafkaTemplate;

    public KafkaJsonProducer(KafkaTemplate<String, String> kafkaTemplate) {
        this.kafkaTemplate = kafkaTemplate;
    }

    public void sendMessage(User userData){
        LOGGER.info(String.format("Message sent  ->%s",userData.toString()));

        Message<User> message= MessageBuilder
                .withPayload(userData)
                .setHeader(KafkaHeaders.TOPIC,jsonTopicName)
                .build();
        kafkaTemplate.send(message);


    }
}
